#include "utconvert.h"

/*̌܂ł̘̓aiݐϘaj*/
static const int monthDays[13]={
	0,31,59,90,120,151,181,212,243,273,304,334,365
};

/*1̕b(=24*60*60)*/
#define SECONDS_PER_DAY 86400

/*1NyearN܂Łi[܂ށj̓߂*/
static long long getDays(int year) {
	long long result;
	if(year<0)return -getDays(-year)-366+365;
	else if(year==0)return 0;
	result=year*365;/*1N͊{365*/
	result+=year/4;/*4Ŋ؂ꂽ[N*/
	result-=year/100;/*100Ŋ؂ꂽ[Nł͂Ȃ*/
	result+=year/400;/*400Ŋ؂ꂽ[N*/
	return result;
}

/*fromYear+1NtoYearN܂ł̓߂*/
static long long getDays2(int fromYear,int toYear) {
	return getDays(toYear)-getDays(fromYear);
}

/*1NyearN܂ł̉[Ň߂*/
static int getLeapYearNum(int year) {
	int result;
	if(year<0)return -getLeapYearNum(-year)-1;
	else if(year==0)return 0;
	result=year/4;/*4Ŋ؂ꂽ[N*/
	result-=year/100;/*100Ŋ؂ꂽ[Nł͂Ȃ*/
	result+=year/400;/*400Ŋ؂ꂽ[N*/
	return result;
}

/*fromYear+1NtoYearN܂ł̉[Ň߂*/
static int getLeapYearNum2(int fromYear,int toYear) {
	return getLeapYearNum(toYear)-getLeapYearNum(fromYear);
}

/*̔N[Nł邩߂*/
static int isLeapYear(int year) {
	return (year%400==0 || (year%4==0 && year%100!=0));
}

/*1970N11@00:00:00̌oߕbԂ*/
long long date2ut(int year,int month,int date,
		int hour,int minute,int second) {
	long long result;
	/*ANZXᔽɂȂs͂Ȃ0Ԃ*/
	if(month<1 || month>12)return 0;
	/* yearN11 00:00:00܂ł̓߂*/
	result=getDays2(1969,year-1);
	/*bɕϊ*/
	result*=SECONDS_PER_DAY;
	/*̓bɕϊđ*/
	result+=monthDays[month-1]*SECONDS_PER_DAY;
	/*[N3ȍ~Ȃ1*/
	if(isLeapYear(year)) {
		if(month>=3)result+=SECONDS_PER_DAY;
	}
	/*̌̓bɕϊđ*/
	result+=(date-1)*SECONDS_PER_DAY;
	/*Ԃ𑫂*/
	result+=hour*60*60;
	/*𑫂*/
	result+=minute*60;
	/*b𑫂*/
	result+=second;
	/*ʂԂ*/
	return result;
}

/*1970N11@00:00:00̌oߕbtɂ*/
void ut2date(ut2date_date_t* result,long long unixTime) {
	int i;
	long long days;
	int yearNum;
	int amariDays;
	int daySeconds;
	int hoseiYear;
	int is2_29;
	if(!result)return;
	if(unixTime>=0) {
		days=unixTime/SECONDS_PER_DAY;
		daySeconds=(int)(unixTime%SECONDS_PER_DAY);
		yearNum=1970+(int)(days/365);
		amariDays=(int)(days%365);
	} else {
		days=(-unixTime)/SECONDS_PER_DAY;
		daySeconds=(int)(SECONDS_PER_DAY-((-unixTime)%SECONDS_PER_DAY));
		if(daySeconds==SECONDS_PER_DAY) {
			daySeconds=0;
		} else days++;
		yearNum=1970-(int)(days/365)-1;
		amariDays=365-(int)(days%365);
	}
	amariDays-=getLeapYearNum2(1969,yearNum-1);
	while(1) {
		if((amariDays>=0 && amariDays<365) ||
			(amariDays==365 && isLeapYear(yearNum)))break;
		if(amariDays<0) {
			hoseiYear=(-amariDays)/365+1;
			amariDays+=hoseiYear*365;
			amariDays+=getLeapYearNum(yearNum-1)-
				getLeapYearNum(yearNum-hoseiYear-1);
			yearNum-=hoseiYear;
		} else if(amariDays>=365) {
			hoseiYear=amariDays/365;
			amariDays=amariDays%365;
			amariDays-=getLeapYearNum(yearNum+hoseiYear-1)-
				getLeapYearNum(yearNum-1);
			yearNum+=hoseiYear;
		} else break;
	}
	is2_29=0;
	if(isLeapYear(yearNum) && amariDays>=59) {
		if(amariDays==59)is2_29=1;
		amariDays--;
	}
	for(i=1;i<=12;i++) {
		if(amariDays>=monthDays[i-1] && amariDays<monthDays[i])break;
	}
	amariDays-=monthDays[i-1];
	if(is2_29)amariDays++;
	result->year=yearNum;
	result->month=i;
	result->date=amariDays+1;
	result->hour=daySeconds/3600;
	result->minute=(daySeconds/60)%60;
	result->second=daySeconds%60;
}
